#include <TM1637.h>

#define DIGITS 4
#define CLK 3
#define DIO 2
#define FSR_PIN_1 A3
#define FSR_PIN_2 A1
#define BUTTON 5
#define BUZZER 6

TM1637 tm(CLK,DIO);

float fsrForce1, fsrForce2;
int startFlag = 0;
bool glassState = false;
long initTime;
float finalTime;
int timer;
float num = 0.0f;

void setup() {
  tm.init();
  tm.set(2);

  Serial.begin(9600);
  Serial.println("start");

  pinMode(FSR_PIN_1, INPUT);
  pinMode(FSR_PIN_2, INPUT);
  pinMode(BUZZER, INPUT);
  pinMode(BUTTON, INPUT_PULLUP);
  //attachInterrupt(digitalPinToInterrupt(BUTTON), buttonPressed, FALLING);
}

void loop() {
  fsrForce1 = getForce(FSR_PIN_1);
  fsrForce2 = getForce(FSR_PIN_2);

  Serial.println(fsrForce1);
  Serial.println(fsrForce2);
  Serial.println();

  int push = digitalRead(BUTTON);
  //Serial.println(push);

  if (push == LOW) {
    startFlag = 0;
    glassState = 0;

    displayNum(0.f, 0, false);
    initTime = millis();
  }

  if (startFlag == 0) {
    if (fsrForce1 > 50 && fsrForce2 > 50) {
      glassState = 1;
      displayNum(0.f, 0, false);
      initTime = millis();
    } else if (fsrForce1 < 50 && fsrForce2 < 50 && glassState) {
      finalTime = millis() - initTime;
      startFlag = 1;
    }
  } else if (startFlag == 1) {
    if (fsrForce1 < 100 && fsrForce2 < 100) {
      num = 0.0f;
      float aux = 0.f;
      finalTime = (millis() - initTime) / 1000.0f;
      num = finalTime;
      aux = (millis() - initTime) % 1000;
      aux = (int)aux / 10.0f;
      aux = aux / 100.0f;
      num += aux;
      displayNum(num, 2, false);
    } else {
      startFlag = 2;
      num = 0.0f;
      float aux = 0.f;
      num = (millis() - initTime) / 1000.0f;
      aux = (millis() - initTime) % 1000;
      aux = (int)aux / 10.0f;
      aux = aux / 100.0f;
      num += aux;
      finalTime = num;
      displayNum(finalTime, 2, false);
      delay(500);
    }
  } else {
    displayNum(finalTime, 2, false);
    tone(BUZZER, 700, 50);
    delay(150);
    tone(BUZZER, 300, 50);
    delay(150);
  }
}

void buttonPressed() {
  
}

float getResistance(int pin) {
  float senVoltage = analogRead(pin) * 5 / 1023;
  return 3300 * (5 / senVoltage - 1);
}

float getForce(int pin) {
  float resistance = getResistance(pin);

  if (resistance <= 600)
    return (1.0 / resistance - 0.00075) / 0.00000032639;
  else
    return (1.0 / resistance)  / 0.000000642857;
}

void displayNum(float num, int decimal, bool show_minus) {

    int number = round(fabs(num) * pow(10, decimal));

    if (decimal == 2) {
        tm.point(true);
    } else {
        tm.point(false);
    }

    for (int i = 0; i < DIGITS - (show_minus && num < 0 ? 1 : 0); ++i) {
        int j = DIGITS - i - 1;

        if (number != 0) {
            tm.display(j, number % 10);
        } else {
            tm.display(j, 0x7f);
        }

        number /= 10;
    }

    if (show_minus && num < 0) {
        tm.display(0, '-');
    }
}
